package Maccess_db;

use strict;
use lib ("/home/web-mycompany/www/maccess/bin","/home/web-mycompany/www/lib");

my $pkg="Maccess_db";

use My;
use DBI;
use Maccess;


#= Globalni promene baliku
my $driver="mysql";
my ($user_prac,$pass_prac,$hostname,$port)=My->sql_user_password;
my $dbh_sys;
my $dbh_usr;


#= Otevreni spojeni s databazi

#--- konekce k SQL systemova (s pravy vlastnika scriptu)
sub dbh_sys {
   if(!defined($dbh_sys)) {
      my $database_sys="maccess";
      my ($user_sys,$pass_sys)=My->sql_user_password;
      $dbh_sys=DBI->connect("DBI:$driver:$database_sys:$hostname:$port",$user_sys,$pass_sys);
   }
   return $dbh_sys;
}

#--- konekce k SQL uzivatelska (s pravy prihlaseneho uzivatele)
sub dbh_usr {
   if(!defined($dbh_usr)) {
      my $dbh_sys=$pkg->dbh_sys;
      my $database_usr="test";
      # Pokud budes chtit aby dotazy bezeli s nejakymi jinymi pravy, tak zde je to misto na zmenu
      my $user_usr=Maccess->get_maccess_user;
      my $sth=$dbh_sys->prepare(q{
         select
            Passwd.password
         from
            Passwd
         where
            Passwd.user=?
      });
      $sth->execute($user_usr);
      my $ref=$sth->fetchrow_arrayref;
      $sth->finish;
      my $pass_usr=$$ref[0];
      $dbh_usr=DBI->connect("DBI:$driver:$database_usr:$hostname:$port",$user_usr,$pass_usr);
   }
   return $dbh_usr;
}


#= Uzavreni spojeni s databazi (provadi se pri ukoncovani interpretu - dokonce i pri die)

END {
   if(defined($dbh_sys)) {
      $dbh_sys->disconnect;
   }
   if(defined($dbh_usr)) {
      $dbh_usr->disconnect;
   }
}

return 1;

