package Blokokruh;

my $pkg="Blokokruh";

use strict;
use My;
use MyXML;
use Output;

#== napojeni na db
my $dbh=My->dbh;
my $dbhpravo=My->dbhpravo;

#- jen menu
sub blokokruhmenu {
   return [["0","odblokovat"],["1","zablokovat"]];
}

#- zablokovani/odblokovani a oznameni vysledku
sub blokokruh {
   my ($pkg_p, $query,$blokokruh,$regokruh)=@_;
   my $blokokruhmenu=$pkg->blokokruhmenu;
   my $idcs=$query->param('_idcs');
   # nastav promenou obsahujici popis zarizeni na ktere bude probihat vystup
   my $outputdev=My->outputdev($query);
   $$outputdev{bezpre}=1;
   # vytvoreni html dokumentu
   my ($docO,$htmlO,$bodyO);
   ($docO,$htmlO,$bodyO,$$outputdev{prvniradek})=MyXML->creahtml($outputdev,$idcs);
   # Vykonny dotaz
   my $sth=$dbhpravo->prepare(q{
      update
         Prava.Okruhy
      set
         Okruhy.blokace=?
      where
         Okruhy.web=? and
         Okruhy.okruh regexp ?
   });
   $sth->execute(1*!(!($blokokruh)),My->web,$regokruh);
   # vystup
   my $outputvar;
   push(@{$outputvar},["Akce:",$$blokokruhmenu[$blokokruh][1]],["Regurln vraz pro okruhy:",$regokruh],["udl:","Provst akci"]);
   $$outputdev{prvniradek}=Output->outputvar($bodyO,$outputvar,$outputdev);
   # ohlaseni vysledku akce
   $bodyO->aT("p",{},"Akce byla provedena a tkala se " . $sth->rows . " okruh.");
   #======= odeslani vystupu na vyst zarizeni
   # vlozeni informaci o zadanych parametrech
   Output->outputprint($docO,$outputdev);
}

return 1;

