package Form;

my $pkg="Form";

use strict;
use My;
use MyXML;

#- tiskne input box pro vkladani dat
sub printI {
   my ($pkg_p, $tO,$name,$polozka)=@_;
   my $value=$$polozka{value};
   # pokud hodnota neprosla kontrolou zmen styl
   if($$polozka{badcheck}) {
      # pro links
      $tO=$tO->aT("font",{color=>"red"});
      $$polozka{style}= "background-color: #ee9999; " . $$polozka{style};
   }
   # formatovani
   if(defined($$polozka{format}) and !$$polozka{badcheck}) {
      my ($pkg_ext,$format_fce)=split(/\-\>/,$$polozka{format});
      $value=$pkg_ext->$format_fce($$polozka{value});
   }
   # zobrazeni
   if($$polozka{type} eq "text" or $$polozka{type} eq "password" or !defined($$polozka{type})) {
      my $type=($$polozka{type} || "text");
      my $inputO=$tO->aT("input",{ type => $type, name => $name });
      if(ref($value)) {
         $inputO->sA("value",$value->aNchilds_toStringHTML);
      }
      else {
         $inputO->sA("value",$value);
      }
      # !! kvuly momentalni verzi prohlizece links navysuji vsecky sirkove polozky o 1 znak (links jinak na posledni pozici totiz roluje text v bunce a pak neni videt zacatek)
      if(defined($$polozka{size}) && !defined($$polozka{width})) {
         $inputO->sA("size",$$polozka{size}+1);
         $inputO->sA("maxlength",$$polozka{size});
      }
      elsif(!defined($$polozka{size}) && defined($$polozka{width})) {
         $inputO->sA("size",$$polozka{width}+1);
      }
      elsif(defined($$polozka{size}) && defined($$polozka{width})) {
         $inputO->sA("size",$$polozka{width}+1);
         $inputO->sA("maxlength",$$polozka{size});
      }
      if(defined($$polozka{style})) {
         $inputO->sA("style",$$polozka{style});
      }
      if(defined($$polozka{onchange})) {
         $inputO->sA("onchange",$$polozka{onchange});
      }
      if(defined($$polozka{onfocus})) {
         $inputO->sA("onfocus",$$polozka{onfocus});
      }
      if(defined($$polozka{onblur})) {
         $inputO->sA("onblur",$$polozka{onblur});
      }
      if($$polozka{disabled}) {
         $inputO->sA("disabled","1");
      }
   }
   elsif($$polozka{type} eq "file") {
      my $inputO=$tO->aT("input",{ type => "file", name => $name, value => $value });
      # !! kvuly momentalni verzi prohlizece links navysuji vsecky sirkove polozky o 1 znak (links jinak na posledni pozici totiz roluje text v bunce a pak neni videt zacatek)
      if(defined($$polozka{size}) && !defined($$polozka{width})) {
         $inputO->sA("size",$$polozka{size}+1);
      }
      elsif(defined($$polozka{width})) {
         $inputO->sA("size",$$polozka{width}+1);
      }
      if(defined($$polozka{style})) {
         $inputO->sA("style",$$polozka{style});
      }
      if($$polozka{disabled}) {
         $inputO->sA("disabled","1");
      }
   }
   elsif($$polozka{type} eq "select") {
      my @selectmenu=$pkg->selectmenu_selectmenu($$polozka{selectmenu});
      my $selectO=$tO->aT("select",{ name=>$name });
      if(defined($$polozka{style})) {
         $selectO->sA("style",$$polozka{style});
      }
      if($$polozka{disabled}) {
         $selectO->sA("disabled","1");
      }
      my $selected=0;
      my $stylebad="";
      while(!$selected) {
         foreach my $selectmenu (@selectmenu) {
            my $style="";
            my $optionval=$$selectmenu[0];
            my $optionO=$selectO->aT("option",{ value=>$optionval },$$selectmenu[1]);
            if($$selectmenu[0] eq $value) {
               $selected=1;
               $optionO->sA("selected","selected");
               if($$polozka{badcheck}) {
                  $style="background-color: #ee9999;";
               }
               else {
                  $style="background-color: #eeeeee;";
               }
            }
            else {
               $style="background-color: #ffffff;";
            }
            $optionO->sA("style",$style.$stylebad);
         }
         @selectmenu=([$value,$value]);
         $stylebad="color: red;";
      }
   }
   elsif($$polozka{type} eq "checkbox") {
      my (@checkmenu, @value, @disabled);
      if(defined($$polozka{checkmenu})) {
         if($$polozka{checkmenu}=~/\-\>/) {
            my ($pkg_ext,$check_fce)=split(/\-\>/,$$polozka{checkmenu});
            @checkmenu=$pkg_ext->$check_fce($name);
         }
         else {
            @checkmenu=@{$$polozka{checkmenu}};
         }
         @value=@{$value};
         @disabled=@{$$polozka{disabled}} if(defined($$polozka{disabled}));
      }
      else {
         @checkmenu=(["1",""]);
         @value=($value);
         @disabled=($$polozka{disabled}) if(defined($$polozka{disabled}));
      }
      my $i=0;
      foreach my $checkmenu (@checkmenu) {
         $tO->aT(undef,{},$$checkmenu[1]);
         my $inputO=$tO->aT("input",{ type => "checkbox", name => $name, value => $$checkmenu[0] });
         if($value[$i]) {
            $inputO->sA("checked","checked");
         }
         if(defined($$polozka{style})) {
            $inputO->sA("style",$$polozka{style});
         }
         if($disabled[$i]) {
            $inputO->sA("disabled","1");
         }
         # zabraneni, aby po enteru byl v IE byl formual odeslan - protoze pak neni nekdy odesilana hodnota cudliku, kvuli vyberovym submit cudlum, kvuli zvyklosti mackat enter pro prechod na dalsi polozku
         $inputO->sA("onkeypress","if(event.keyCode==13) { event.returnValue=false; }");
         $tO->aT(undef,{}," ");
         ++$i;
      }
   }
   elsif($$polozka{type} eq "textarea") {
      my $textareaO=$tO->aT("textarea",{ name=>$name, id=>$name });
      if(ref($value)) {
         $textareaO->aT(undef,{},$value->aNchilds_toStringHTML);
      }
      else {
         $textareaO->aT(undef,{},$value);
      }
      if(defined($$polozka{cols})) {
         $textareaO->sA("cols",$$polozka{cols});
      }
      if(defined($$polozka{rows})) {
         $textareaO->sA("rows",$$polozka{rows});
      }
      if(defined($$polozka{style})) {
         $textareaO->sA("style",$$polozka{style});
      }
      if($$polozka{disabled}) {
         $textareaO->sA("disabled","1");
      }
   }
   elsif($$polozka{type} eq "htmlarea") {
      my $polozkatext;
      %$polozkatext=%$polozka;
      $$polozkatext{type}="textarea";
      $pkg->printI($tO,$name,$polozkatext);
      if(1) { # specialne, aby fungoval HTML editorek HTMLArea
         $tO->aT("script",{ type => "text/javascript" },
            q{
               var editor = new HTMLArea("}.$name.q{");
               editor.generate();
            }
         );
      }
   }
   elsif($$polozka{type} eq "button") {
      my $inputO=$tO->aT("input",{ type => "button", name => $name, value => $value });
      if(defined($$polozka{onclick})) {
         $inputO->sA("onclick",$$polozka{onclick});
      }
      if(defined($$polozka{style})) {
         $inputO->sA("style",$$polozka{style});
      }
      if($$polozka{disabled}) {
         $inputO->sA("disabled","1");
      }
   }
   elsif($$polozka{type} eq "hidden" or $$polozka{type} eq "show") {
      if(defined($$polozka{print})) {
         my $showvalue=$value;
         if(defined($$polozka{selectmenu})) {
            my @selectmenu=$pkg->selectmenu_selectmenu($$polozka{selectmenu});
            foreach my $selectmenu (@selectmenu) {
               if($$selectmenu[0] eq $value) {
                  $showvalue=$$selectmenu[1];
               }
            }
         }
         my $spanO=$tO->aT("span");
         if($$polozka{html} and !ref($showvalue)) {
            my $docxhtml=XML::LibXML::Document->new;
            my $xhtmlO=MyXML->new("xhtml");
            $docxhtml->setDocumentElement($xhtmlO);
            $xhtmlO->aNchilds_fromStringHTML($showvalue);
            $showvalue=$xhtmlO;
         }
         if(ref($showvalue)) {
            $spanO->aNchilds($showvalue);
         }
         else {
            $spanO->aT(undef,{},$showvalue);
         }
         if(defined($$polozka{style})) {
            $spanO->sA("style",$$polozka{style});
         }
      }
      if($$polozka{type} eq "hidden") {
         my $inputO=$tO->aT("input",{ type => "hidden", name => $name });
         if(ref($value)) {
            $inputO->sA("value",$value->aNchilds_toStringHTML);
         }
         else {
            $inputO->sA("value",$value);
         }
      }
   }
   # pokud hodnota neprosla kontrolou zmen styl - ukonceni
   # submit
   if(defined($$polozka{submit})) {
      $tO->aT(undef,{}," ");
      my $inputO=$tO->aT("input",{ type => "submit", name => "submit", value => $$polozka{submit} });
   }
}

#- pomocna fce vracejici v poli moznosti selectmenu
sub selectmenu_selectmenu {
   my ($pkg_p, $selectmenu)=@_;
   my @selectmenu;
   if($selectmenu=~/\-\>/) {
      my ($pkg_ext,$select_fce)=split(/\-\>/,$selectmenu);
      @selectmenu=$pkg_ext->$select_fce;
   }
   elsif(defined($selectmenu)) {
      @selectmenu=@{$selectmenu};
   }
   return @selectmenu;
}

#- fce volana v ramci definice a upravujici preddefinovane hodnoty polozek a to z $query (kvuli pamatovaku z ceho vystup vznikl...) a z cookie
sub values_predef {
   my ($pkg_p, $polozky,$query)=@_;
   foreach my $name (grep(/^[^_]/,keys %{$polozky})) {
      if(defined($query->param($name))) {
         $$polozky{$name}{value}=$query->param($name);
         if(defined($$polozky{$name}{cookie})) { # Puvodne jsem mel tendenci v prazdnych "empty" pripadech cookie nezaznamenavat: and (!defined($$polozky{$name}{empty}) or length($query->param($name)))
            cookie($$polozky{$name}{cookie},$query->param($name));
         }
      }
      elsif(defined($$polozky{$name}{cookie}) and defined(cookie($$polozky{$name}{cookie}))) {
         $$polozky{$name}{value}=cookie($$polozky{$name}{cookie});
      }
   }
   return $polozky;
}

#- pripadne nacteni udaju z formulare a jejich nasledna kontrola
sub values_from_form {
   my ($pkg_p, $polozky,$query)=@_;
   #- nacteni udaju z formulare
   if(defined($query)) {
      foreach my $name ($pkg->names($polozky)) {
         if(!$$polozky{$name}{optionally} or defined($query->param($name))) { # ZMENA - novy parametr "optionally" zajistuje, ze pokud formular nevratil hodnotu promenne zustane jeji hodnotou ta prednastavena z definice (pokud tedy byla preddefinovana ve value)
            if(!defined($$polozky{$name}{checkmenu})) {
               $$polozky{$name}{value}=$query->param($name);
               ## ZMENA 2003-06-27 - nyni resim i nacitani souboru z formulare
               my $fh=$query->upload($name);
               if(defined($fh)) {
                  $$polozky{$name}{file}{name}=$$polozky{$name}{value};
                  $$polozky{$name}{file}{mimetype}=$query->uploadInfo($$polozky{$name}{file}{name})->{'Content-Type'};
                  while(my $line=<$fh>) {
                     $$polozky{$name}{file}{body}.=$line;
                  }
               }
            }
            else { # jen u checkboxu s checkmenu
               foreach my $checkmenu (@{$$polozky{$name}{checkmenu}}) {
                  my $value=0;
                  if(grep(/^\Q$$checkmenu[0]\E$/,$query->param($name))) {
                     $value=1;
                  }
                  push(@{$$polozky{$name}{value}},$value);
               }
            }
         }
      }
   }
   #- kontrola udaju
   my $checkok=1;
   foreach my $name ($pkg->names($polozky)) {
      ## ZMENA 2203-11-18 - napocatku vzdy badcheck vynuluji (nekdy dulezite u vicekrat volani fce values_from_form)
      $$polozky{$name}{badcheck}="0";
      ## ZMENA 2002-08-22 - zmeny v souvislosti se zavedenim moznosti "empty"
      if(defined($$polozky{$name}{empty}) and !length($$polozky{$name}{value})) {
         ## ZMENA 2002-10-24 - zavedeni mit v empty i volani fce obdobne jako u check (tedy ne jen pevna hodnota, ci hodnota vracena fci drive)
         if($$polozky{$name}{empty}=~/\-\>/) {
            my ($pkg_ext,$empty_fce)=split(/\-\>/,$$polozky{$name}{empty});
            $$polozky{$name}{value}=$pkg_ext->$empty_fce($$polozky{$name}{value},$name,$polozky);
         }
         else {
            $$polozky{$name}{value}=$$polozky{$name}{empty}; # tedy pak hodnota neni nikdy undef
         }
      }
      # v druhe casti podminky (za "and") jsem chtel mit jen ($$polozky{$name}{empty} ne "") ale nejak to nefachcilo (proste pry undef je ekvivalntni "" coz je nejaka blbost...)
      # inac kontroluji zde vlastne i hodnotu, kterou vnutil pripadny obsah v $$polozky{$name}{empty} az na pripad kdy je v $$polozky{$name}{empty} jen ""
      if(!defined($$polozky{$name}{empty}) or length($$polozky{$name}{value})) {
         # kontrola pomoci kontrolni fce
         if(defined($$polozky{$name}{check})) {
            my ($pkg_ext,$check_fce)=split(/\-\>/,$$polozky{$name}{check});
            my $value=$pkg_ext->$check_fce($$polozky{$name}{value},$name,$polozky);
            if(!defined($value)) {
               $$polozky{$name}{badcheck}="1";
               $checkok=0;
            }
            else {
               $$polozky{$name}{value}=$value;
            }
         }
         # !!! Pozn: Zde nize by to chtelo predelat a rozsirit tak schopnosti
         #           checkmin a checkmax.
         #           Napred by to na zaklade checkmin a checkmax, chtelo zjistit
         #           zda se jedna o cislo ci datum (mozna i retezec) a pak dle
         #           zjisteni nasadir ruzne druhy porovnavani.
         #           Zatim je predpokladano, ze se jedna jen o cisla...
         # promena pozdeji uzita ke kontrole poctu desetinych mist
         my $checkmaxdec;
         # kontrola dimenze - minimum
         if(!$$polozky{$name}{badcheck} and defined($$polozky{$name}{checkmin})) {
            if(!($$polozky{$name}{value}>=$$polozky{$name}{checkmin})) {
               $$polozky{$name}{badcheck}="1";
               $checkok=0;
            }
            else {
               if($$polozky{$name}{checkmin}=~/^[\+\-]{0,1}\d+\.{0,1}(\d*)$/) {
                  $checkmaxdec=length($1);
               }
               else {
                  $checkmaxdec=undef;
               }
            }
         }
         # kontrola dimenze - maximum
         if(!$$polozky{$name}{badcheck} and defined($$polozky{$name}{checkmax})) {
            if(!($$polozky{$name}{value}<=$$polozky{$name}{checkmax})) {
               $$polozky{$name}{badcheck}="1";
               $checkok=0;
            }
            else {
               if($$polozky{$name}{checkmax}=~/^[\+\-]{0,1}\d+\.{0,1}(\d*)$/) {
                  if(length($1)>$checkmaxdec) {
                     $checkmaxdec=length($1);
                  }
               }
               else {
                  $checkmaxdec=undef;
               }
            }
         }
         # kontrola desetinych mist
         if(!$$polozky{$name}{badcheck} and defined($checkmaxdec)) {
            if($$polozky{$name}{value}!~/^[\+\-]{0,1}\d+\.{0,1}(\d*?)0*$/ or length($1)>$checkmaxdec) {
               $$polozky{$name}{badcheck}="1";
               $checkok=0;
            }
         }
      }
   }
   return ($polozky,$checkok);
}

#- tisk vnitrku standardniho formulare
sub form_val_list {
   my ($pkg_p, $tO,$polozky,$cudle,$method)=@_;
   if(!defined($method)) {
      $method="post";
   }
   my $formO=$tO->aT("form", { action => My->okruh, method => $method });
   ## ZMENA 2003-06-16 kvuli type="file" jsem zde dodal atribut enctype
   if($method eq "post") {
      $formO->sA("enctype","multipart/form-data");
   }
   # tisk hodnot polozek
   my $divO=$formO->aT("div",{ class=>"form", style => "padding: 10px;" });
   my $polozky_noprint_hidden;
   my $layout=$pkg->layout($polozky);
   # hlavni horizontalni casti
   my $numblok;
   foreach my $blok (@{$layout}) {
      ++$numblok;
      my $tableO=$divO->aT("table", { cellpadding => "5px" } );
      my $colgroupO=$tableO->aT("colgroup");
      foreach my $subblok (@{$blok}) {
         $colgroupO->aT("col",{ valign=>"top" });
      }
      my $trO=$tableO->aT("tr");
      # deleni horizontalni cast na vertikalni casti
      foreach my $subblok (@{$blok}) {
         my $tdO=$trO->aT("td", { valign=>"top" });
         my $subblokstyle=$$subblok{style};
         if($subblokstyle!~/(^|\s)margin(-top){0,1}:/ and $numblok>1) {
            $subblokstyle= "margin-top: 5px; " . $subblokstyle;
         }
         my $table2O=$tdO->aT("table",{ class=>"form", style => $subblokstyle });
         if($$subblok{type} eq "table") {
            $table2O->sA("cellspacing", "5px");
         }
         # zajisteni, moznosti vytisteni sloupcu u $$subblok{type} eq "table"
         my @indexes;
         if($$subblok{type} eq "table") {
            @indexes=(0,1);
         }
         else {
            @indexes=(1);
         }
         # u pruchodu s $index==0 bude vytisteno zahlavi u $$subblok{type} eq "table", tento chod s $index==0 u jinych typu vubec neni
         foreach my $index (@indexes) {
            my @subbloknames;
            if($index==0) {
               ### ZMENA 2004-02-05 - v rezimu "table" v programech nekdy nektere radky likviduji, protoze neobsahuji klicove slovo a beru je jako prazdne; ovsem zpusob, kterym to provadim, je likvidace promenych, ale neprocistim jiz "_layout", coz bych asi mel spravne delat; protoze to vsak nedelam, proto nize se snazim najit prvni radek, ktery ma opravdu definovanou hodnotu a z toho radku pak vezmu nadpisy sloupcu
               my $row=1;
               for(my $i=0;$i<=$#{$$subblok{names}};$i+=$$subblok{cols}) {
                  if(defined($$polozky{$$subblok{names}[$i]})) {
                     @subbloknames=@{$$subblok{names}}[$i..($row*$$subblok{cols}-1)];
                  }
                  ++$row;
               }
            }
            else {
               @subbloknames=@{$$subblok{names}};
            }
            my $col=0;
            my $tr2O;
            # tisk polozek
            foreach my $name (@subbloknames) {
               # polozky, ktere maji byt viditelne
               if(defined($$polozky{$name}{print})) {
                  if($$subblok{type} ne "table" or ($col % $$subblok{cols})==0) {
                     $tr2O=$table2O->aT("tr");
                  }
                  # nadpis hodnoty
                  if($$subblok{type} ne "table" or $index==0) {
                     my $td21O=$tr2O->aT("td",{ class=>"form" });
                     if(defined($$polozky{$name}{title})) {  # ? asi by se melo prejmenovat na printtitle
                        $td21O->sA("title",$$polozky{$name}{title});
                     }
                     if(ref($$polozky{$name}{print})) {
                        $td21O->aNchilds($$polozky{$name}{print});
                     }
                     elsif(length($$polozky{$name}{print})) {
                        if(defined($$polozky{$name}{href})) { # ? asi by se melo prejmenovat na printhref
                           $td21O=$td21O->aT("a",{ href => $$polozky{$name}{href} });
                        }
                        if($$polozky{$name}{pri}) { # ? mozna zrale na zruseni
                           $td21O=$td21O->aT("b");
                        }
                        $td21O=$td21O->aT("i");
                        my $printstyle=$$polozky{$name}{printstyle};
                        if(defined($$polozky{$name}{empty}) and $printstyle!~/(^|\s)color:/) {
                           $printstyle= "color: #777777; " . $printstyle;
                        }
                        if(defined($printstyle)) {
                           $td21O=$td21O->aT("span", { style => $printstyle });
                        }
                        $td21O->aT(undef,{},$$polozky{$name}{print});
                        if(defined($$polozky{$name}{empty}) and $printstyle=~/(^|\s)color:\s*#777777[;\s]/) {
                           if(length($$polozky{$name}{empty})) {
                              $td21O->aT(undef,{},"+");
                           }
                           else {
                              $td21O->aT(undef,{},"-");
                           }
                        }
                        if($$subblok{type} ne "table") {
                           $td21O->aT(undef,{},": ");
                        }
                     }
                  }
                  # hodnota
                  if($index==1) {
                     my $td22O=$tr2O->aT("td",{ class=>"form" });
                     $pkg->printI($td22O,$name,$$polozky{$name});
                     # tisk pripadne poznamky
                     if(defined($$polozky{$name}{printpozn})) {
                        if(ref($$polozky{$name}{printpozn})) {
                           $td22O->aNchilds($$polozky{$name}{printpozn});
                        }
                        else {
                           $td22O->aT(undef,{}," (".$$polozky{$name}{printpozn}.")");
                        }
                     }
                  }
               }
               # pamatovak pro hidden polozky u nichz se nema zobrazovat ani hodnota (neviditelne hodnoty vyjedes pozdeji)
               elsif($$polozky{$name}{type} eq "hidden") {
                  $$polozky_noprint_hidden{$name}=$$polozky{$name};
                  push(@{$$polozky_noprint_hidden{_layout}[0][0]{names}}, $name)
               }
               if($$subblok{type} eq "table") {
                  ++$col;
               }
            }
         }
      }
   }
   # tisk hidden polozek u nichz se nema zobrazovat ani hodnota
   my $div2O=$divO->aT("div",{ style=>"display: none" });
   foreach my $name ($pkg->names($polozky_noprint_hidden)) {
      $pkg->printI($div2O,$name,$$polozky_noprint_hidden{$name});
   }
   # tisk cudliku pro ovladani formulare
   my $pO=$formO->aT("p");
   foreach my $cudl (@{$cudle}) {
      $pO->aT("input", { type => "submit", name => "submit", value => $cudl });
      $pO->aT(undef, {}, "\x{a0}")
   }
   ## ZMENA 2003-04-18 - radek nize doplnen - predtim nebylo zajimave co fce vraci
   return ($formO,$divO);
}

#- fce vracejici seznam polozek names z "_layout" a zajistujici i zpetnou kompatibilitu s "_poradi"
sub names {
   my ($pkg_p, $polozky)=@_;
   my @names;
   # nove fce uzivaji "_layout"
   if(defined($$polozky{_layout})) {
      foreach my $blok (@{$$polozky{_layout}}) {
         foreach my $subblok (@{$blok}) {
            push(@names,@{$$subblok{names}});
         }
      }
   }
   # z duvodu kompatibiliti u funkci, ktere neuzivaji "_layout", ale "_poradi"
   elsif(defined($$polozky{_poradi})) {
      push(@names,@{$$polozky{_poradi}});
   }
   return @names;
}

#- fce jen pro zpetnou kompatibilitu, pro funkcnost funkci, ktere jeste nepresli na "_layout"
#  !!! fce je vhodna jen pro uziti zde v baliku - neuzivej ji jinde !!!
sub layout {
   my ($pkg_p, $polozky)=@_;
   my $layout;
   # nove fce uzivaji "_layout" a na to bys mel predelat i stare funkce
   if(defined($$polozky{_layout})) {
      $layout=$$polozky{_layout};
   }
   # stare funkce neuzivaji "_layout", ale "_poradi" a "_zalomeni"
   else {
      my $zalomeni; # jsou dva mozne zapisy u $$polozky{_zalomeni}
      if(!ref($$polozky{_zalomeni}[0])) {
         # prvni zpusob zapisu: _zalomeni => ["a","b"] umoznuje jen jeden blok
         # - hodnoty rikaji, za jakou polozku ma v ramci bloku dojit k zalomeni,
         #   tedy za polozkou "a" a pak za polozkou "b"
         #   (vysledkem je tabulka o trech sloupcich)
         $$zalomeni[0]=$$polozky{_zalomeni};
      }
      else {
         # druhy zpusob zapisu: _zalomeni => [["a"],"b",["c"]] umoznuje vice
         # samostatne zalamovanych bloku
         # - hodnota "b" rika, ze polozka "b" je prvni polozka
         #   noveho bloku
         # - samotny prvni blok je zalomen za polozkou "a"
         #   (tedy jde o blok, kterym je tabulka o dvou sloupcich)
         # - samotny druhy blok je take zalomen a to za polozkou "c"
         #   (tedy jde o blok, kterym je taktez tabulka o dvou sloupcich)
         $zalomeni=$$polozky{_zalomeni};
      }
      my $blok2=0;
      my $table=0;
      foreach my $name ($pkg->names($polozky)) {
         if($name eq $$zalomeni[$blok2+1]) {
            $blok2+=2;
            $table=0;
         }
         push(@{$$layout[$blok2/2][$table]{names}},$name);
         if($name eq $$zalomeni[$blok2][$table]) {
            ++$table;
         }
      }
   }
   return $layout;
}

return 1;

