package Vyroba_evidence_odpracvyk;

my $pkg="Vyroba_evidence_odpracvyk";

use strict;
use My;
use Info;

#==== Globalni promena tohohle balicku
my $dbh=My->dbh;


sub odpracvykocsouhrn {
   my ($pkg_p, $ucetobd,$strmzda,$oc,$volba)=@_;
   my @numbercolname=("hod","nhod","nkc");
   # zjisteni souhrnych udaju
   my (%souhrn);
   #- Priprava dotazu
   my ($dotaz,@dotazpara);
   # select
   $dotaz.=q{
      select
         substring(Odpracvyk.dm,1,1) as dm1,
         sum(Odpracvyk.hod) as hod,
         sum(Odpracvyk.nhod) as nhod,
         sum(Odpracvyk.nkc) as nkc
      from
         Vyroba_evidence.Odpracvyk
   };
   if(!$$volba{ciziorg}) {
      $dotaz.=q{
         where
            Odpracvyk.org=?
      };
      push(@dotazpara,(get_env("org")));
   }
   else {
      $dotaz.=q{
         where
            1
      };
   }
   $dotaz.=q{
         and Odpracvyk.ucetobd=?
         and Odpracvyk.strmzda=?
         and Odpracvyk.oc=?
   };
   push(@dotazpara,($ucetobd,$strmzda,$oc));
   if(length($$volba{castdm})) {
      $dotaz.=q{
         and Odpracvyk.dm regexp ?
      };
      push(@dotazpara,($$volba{castdm}));
   }
   $dotaz.=q{
      group by
         dm1
   };
   my $sth_souhrn=$dbh->prepare($dotaz);
   $sth_souhrn->execute(@dotazpara);
   while(my $ref_souhrn=$sth_souhrn->fetchrow_hashref) {
      foreach my $colname (@numbercolname) {
         $souhrn{celkem}{$$ref_souhrn{dm1}}{$colname}+=$$ref_souhrn{$colname};
      }
   }
   $sth_souhrn->finish;
   return \%souhrn;
}
   
return 1;

