// skryvani a odkryvani v "list" (kusovnikovem) vystupu - vsechny nasledujici UL elementy
function ShowAll_or_HiddenAll_items(oLI,show) {
   Show_or_Hidden_items(oLI,show);
   var oLIs;
   // Poznamka: viz poznamka u fce Show_or_Hidden_items
   // MS IE
   if(isIE) {
      oLIs=oLI.getElementsByTagName("LI");
   }
   // Mozilla
   else {
      var oNext=oLI;
      while(oNext=oNext.nextSibling) {
         if(oNext.tagName=="UL") {
            oLIs=oNext.getElementsByTagName("LI");
            break;
         }
         else if(oNext.tagName) {
            break;
         }
      }
   }
   for(var i=0; i<oLIs.length; i++) {
      if(oLIs[i].className=="folderClose" || oLIs[i].className=="folderOpen") {
         Show_or_Hidden_items(oLIs[i],show);
      }
   }
   return true;
}


// skryvani a odkryvani v "list" (kusovnikovem) vystupu - jeden nasledujici UL element
function Show_or_Hidden_items(oLI,show) {
   var oUL;
   // Poznamka: MS IE ma vnorene UL v ramci prislusneho LI,
   //           a tedy jde o dite, u Mozilly je UL v hiearchii na stejne
   //           urovni jako LI (ja to tam tak i posilam).
   //           MS IE to tedy interpretuje jinak nez ja to tam posilam
   //           otazka kazdopadne zni zda to posilam dobre v souladu
   //           s normamy w3c a to mozna nedelam.
   // MS IE
   if(isIE) {
      oChilds=oLI.childNodes;
      for(var i=0; i<oChilds.length; i++) {
         var oNext=oChilds[i];
         // pokud nejaky z nasledujicich nodu je ul
         if(oNext.tagName=="UL") {
            if(oNext.className=="folderItemsShow" || oNext.className=="folderItemsHidden") {
               oUL=oNext;
            }
            break;
         }
      }
   }
   // Mozilla
   else {
      var oNext=oLI;
      while(oNext=oNext.nextSibling) {
         // pokud nejaky z nasledujicich nodu je ul
         if(oNext.tagName=="UL") {
            if(oNext.className=="folderItemsShow" || oNext.className=="folderItemsHidden") {
               oUL=oNext;
            }
            break;
         }
         // pokud nejaky z nasledujicich nodu neni ani text (nema definovan tagName) tak koncis
         else if(oNext.tagName) {
            break;
         }
      }
   }
   if(oUL) {
      if(show==-1) {
         oUL.className = oLI.className=="folderClose" ? "folderItemsShow" : "folderItemsHidden";
         oLI.className = oLI.className=="folderClose" ? "folderOpen" : "folderClose";
      }
      else {
         if(show) {
            oUL.className = "folderItemsShow";
            oLI.className = "folderOpen";
         }
         else {
            oUL.className = "folderItemsHidden";
            oLI.className = "folderClose";
         }
      }
   }
   return true;
}


// fce zobrazi kontextove menu
function showMyMenu(event,myMenu) {
   hideMyMenu();
   var bodyT=document.body;
   var menuT=document.createElement("DIV");
   menuT.id="MyMenu";
   menuT.style.border="1px solid #000000";
   menuT.style.backgroundColor="#FAFAFA";
   menuT.style.position="absolute";
   menuT.style.padding="3px";
   menuT.style.fontSize="10px";
   menuT.style.fontFamily="Arial";
   menuT.style.fontWeight="bold";
   menuT.style.width="120px"; // bez specifikace dochazelo u Mozilly u dlouhych tabulek k lamani menu
   //menuT.style.MozBorderRadius="5px";
   var pos=mousePos(event);
   menuT.style.left=pos[0];
   menuT.style.top=pos[1];
   for(var i=0; i<myMenu.length; i++) {
      var divT=document.createElement("DIV");
      divT.style.margin="5px";
      var aT=document.createElement("A");
      aT.href=myMenu[i][1];
      if(myMenu[i][2]) {
         aT.className=myMenu[i][2];
      }
      aT.style.textDecoration="none";
      aT.style.padding="2px";
      aT.style.color="black";
      aT.style.width="100px";
      var textT=document.createTextNode(myMenu[i][0]);
      aT.appendChild(textT);
      divT.appendChild(aT);
      menuT.appendChild(divT);
   }
   // zobrazeni menu
   bodyT.appendChild(menuT);
   return false;
}


// fce skryje kontextove menu
function hideMyMenu() {
   if(menuT=document.getElementById('MyMenu')) {
      document.body.removeChild(menuT);
   }
   return true;
}


// fce zobrazi jen radky s prislusnym @chosen
function tableFilter(chosen) {
   if(activeTable) {
      var trT=activeTable.getElementsByTagName("TR");
      if(chosen>=0) {
         var chosenName="chosen"+chosen;
         for(var i=0; i<trT.length; i++) {
            if(trT[i].className==chosenName) {
               trT[i].style.display="";
            }
            else if(trT[i].className.substring(0,6)=="chosen") {
               trT[i].style.display="none";
            }
         }
      }
      else {
         for(var i=0; i<trT.length; i++) {
            if(trT[i].className.substring(0,6)=="chosen") {
               trT[i].style.display="";
            }
         }
      }
   }
   hideMyMenu();
}

// fce oznaci vsechny radky
function tableFilterMarkAll(chosen) {
   if(activeTable) {
      var trT=activeTable.getElementsByTagName("TR");
      var chosenName="chosen"+chosen;
      for(var i=0; i<trT.length; i++) {
         if(trT[i].className.substring(0,6)=="chosen") {
            trT[i].className=chosenName;
         }
      }
      tableFilter(-1);
   }
   hideMyMenu();
}


// vraci souradnice, kde je kurzor mysi
function mousePos(event){
   var pos = new Array();
   if(!event) var event=window.event; // MS IE
   if(event.pageX || event.pageY) {
      pos[0] = event.pageX;
      pos[1] = event.pageY;
   }
   else if(event.clientX || event.clientY) {
      pos[0] = event.clientX;
      pos[1] = event.clientY;
      if (isIE){
         pos[0] += document.body.scrollLeft;
         pos[1] += document.body.scrollTop;
      }
   }
   return pos;
}


// zajistuje, ze pres shift je stale k dispozici klasicke kontextove menu
function showBrowMenu(event) {
   if(!event) var event=window.event; // MS IE
   if(event.shiftKey) {
      return true;
   }
   else {
      if(activeTable=tableElement(event)) {
         showMyMenu(event,myMenuTable);
         return false;
      }
      else if(formElement(event)) {
         showMyMenu(event,myMenuForm);
         return false;
      }
      else {
         return true;
      }
   }
}


// fce vraci nejblizsi rodicovsky table node, kde byla vyvolana udalost a kdyz neexistuje tak vraci false
function tableElement(event) {
   if(!event) var event=window.event; // MS IE
   var eSrc=eventElement(event);
   while(eSrc = eSrc.parentNode) {
      if(eSrc.tagName=="TABLE") {
         if(myMenuTable[0] && eSrc.className=="o1") {
            return eSrc;
         }
         else {
            return false;
         }
      }
   }
   return false;
}


// fce vraci nejblizsi rodicovsky form node, kde byla vyvolana udalost a kdyz neexistuje tak vraci false
function formElement(event) {
   if(!event) var event=window.event; // MS IE
   var eSrc=eventElement(event);
   while(eSrc = eSrc.parentNode) {
      if(eSrc.tagName=="FORM") {
         if(myMenuForm[0]) {
            return eSrc;
         }
         else {
            return false;
         }
      }
   }
   return false;
}


// fce vraci node, ktery vyvolal udalost
function eventElement(event) {
   var eSrc;
   // MS IE
   if(isIE) {
      eSrc = event.srcElement;
   }
   // Mozilla
   else {
      eSrc = event.target;
   }
   return eSrc;
}


// hlavni fce, spustena kdykoliv je v ramci dokumentu proveden click mysi
function document_click(event) {
   if(!event) var event=window.event; // MS IE
   var eSrc=eventElement(event);
   // pokud se jedna o link tak skonci (dulezite pro funkcnost linku v samotnem menu)
   if(eSrc.tagName=="A") {
      return true;
   }
   // zjisteni zda bylo kliknuto pravym cudlem
   var rightclick;
   if(event.which) {
      rightclick = (event.which == 3);
   }
   else if(event.button) {
      rightclick = (event.button == 2);
   }
   // nebyl stisknut pravy cudl
   if(!rightclick) {
      // pripadna likvidace menu
      hideMyMenu();
      // pro "list" (kusovnikovy) vystup
      if(!event.altKey && (eSrc.className=="folderClose" || eSrc.className=="folderOpen")) {
         return Show_or_Hidden_items(eSrc,-1);
      }
      else if(eSrc.className=="folderClose") {
         return ShowAll_or_HiddenAll_items(eSrc,1);
      }
      else if(eSrc.className=="folderOpen") {
         return ShowAll_or_HiddenAll_items(eSrc,0);
      }
      // pro "table" vystup
      else {
         while(eSrc = eSrc.parentNode) {
            if(eSrc.tagName=="TR") {
               if(eSrc.className.substring(0,6)=="chosen") {
                  if(eSrc.className!="chosen1" && eSrc.className!="chosen2" && !event.altKey) {
                     eSrc.className="chosen1";
                  }
                  else if(eSrc.className!="chosen2" && event.altKey) {
                     eSrc.className="chosen2";
                  }
                  else {
                     eSrc.className="chosen0";
                  }
               }
               return true;
            }
            else if(eSrc.tagName=="A") {
               return true;
            }
         }
         return true;
      }
   }
   // byl stisknut pravy cudl
   else {
      return true;
   }
}


// definice potrebnych globalnich promenych
var isOpera = (navigator.userAgent.indexOf('Opera') != -1);
var isIE = (!isOpera && navigator.userAgent.indexOf('MSIE') != -1)
var activeTable=false;


// definice menu
var myMenuTable = new Array();
myMenuTable[0] = new Array(5);
myMenuTable[0][0] = "zapnout filtr";
myMenuTable[0][1] = "javascript:tableFilter(0)";
myMenuTable[0][2] = "chosen0";
myMenuTable[1] = new Array(5);
myMenuTable[1][0] = "zapnout filtr";
myMenuTable[1][1] = "javascript:tableFilter(1)";
myMenuTable[1][2] = "chosen1";
myMenuTable[2] = new Array(5);
myMenuTable[2][0] = "zapnout filtr";
myMenuTable[2][1] = "javascript:tableFilter(2)";
myMenuTable[2][2] = "chosen2";
myMenuTable[3] = new Array(5);
myMenuTable[3][0] = "vypnout filtr";
myMenuTable[3][1] = "javascript:tableFilter(-1)";
myMenuTable[4] = new Array(5);
myMenuTable[4][0] = "odoznait ve";
myMenuTable[4][1] = "javascript:tableFilterMarkAll(0)";


// definice formularoveho menu
var myMenuForm = new Array();


// nize zajistuji aby po kliknuti mysi v dokumentu doslo ke spusteni hlavni fce
document.onclick = document_click;
document.oncontextmenu = showBrowMenu;

